{-# OPTIONS_GHC -Wno-missing-signatures #-}
module Functions
  ( isImageFilename
  , convertedImageFilename
  , listDirectory
  , readTemplate
  , convertImage
  , saveFile
  , runPandoc
  ) where

import FunctionImplementations.Pure
import FunctionImplementations.IO
import ComputationM
import Types
import Dependency

isImageFilename :: Token FilePath -> ComputationM Bool
isImageFilename = runFunction IsImageFilename
convertedImageFilename :: Token FilePath -> ComputationM FilePath
convertedImageFilename = runFunction ConvertedImageFilename

listDirectory :: Token FilePath -> ComputationM [FilePath]
listDirectory = runFunctionIO ListDirectory
readTemplate :: Token FilePath -> ComputationM Template
readTemplate = runFunctionIO ReadTemplate
convertImage :: Token ((FilePath, FilePath), ImageConversionSettings) -> ComputationM ()
convertImage = runFunctionIO ConvertImage
saveFile :: Token (String, FilePath) -> ComputationM ()
saveFile = runFunctionIO SaveFile
runPandoc :: Token String -> ComputationM String
runPandoc = runFunctionIO RunPandoc
