{-# LANGUAGE FunctionalDependencies #-}
module Types where

import Data.ByteString (ByteString)
import Language.Haskell.TH.Syntax

data ImageConversionSettings = ResizeToWidth Int
  deriving (Show, Lift)

data TemplatePart = Literal String
                  | KeyValue String
  deriving (Show, Lift)

data Template = Template [TemplatePart]
  deriving (Show, Lift)

-- class (Show f, Lift f) => IsFunctionId f

-- class (IsFunctionId f, SourceState a) => IsFunction f a b | f -> a b where
--   runF :: f -> a -> b

-- class (Show f, Lift f) => IsFunctionIOId f
-- class (IsFunctionIOId f, SourceState a) => IsFunctionIO f a b | f -> a b where
--   runFIO :: f -> a -> IO b

-- class SourceState a where
--   stateOfSource :: a -> IO ByteString


data Function = IsImageFilename
              | ConvertedImageFilename
  deriving (Show, Lift)

data FunctionIO = ListDirectory
                | ReadTemplate
                | ConvertImage
                | SaveFile
                | RunPandoc
  deriving (Show, Lift)


-- class (Show w, Lift w) => Witness w a | w -> a where

-- data WImageConversionSettings = WImageConversionSettings deriving (Show, Lift)
-- instance Witness WImageConversionSettings ImageConversionSettings

data Value = ImageConversionSettings ImageConversionSettings
           | String String
  deriving (Show, Lift)

class Valuable a where
  toValue :: a -> Value

instance Valuable ImageConversionSettings where
  toValue = ImageConversionSettings

instance Valuable String where
  toValue = String
